/****************************************************************
Copyright (c) 1998 Sandro Sigala <ssigala@globalnet.it>.
All rights reserved.

Permission to use, copy, modify, and distribute this software
and its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that the copyright notice and this
permission notice and warranty disclaimer appear in supporting
documentation, and that the name of the author not be used in
advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

The author disclaim all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall the author be liable for any
special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
****************************************************************/

#ifndef MAPGRIDFRAME_H
#define MAPGRIDFRAME_H

#include <qframe.h>

#include "kreptoned.h"

class QPixmap;
class Map;

class MapGridFrame : public QFrame {
	Q_OBJECT

signals:
	void pressedButton(int, int, int);
	void changedCoordinates(int, int);

public:
	int map_sx, map_sy;
	int map_width, map_height;

	MapGridFrame(QPixmap *xsprites, QWidget *parent = 0, const char *name = 0);
	void setSprite(Sprite s) { current_sprite = s; }
	void setMap(Map *xmap) { map = xmap; }
	void setSize(int w, int h);

private:
	QPixmap *sprites;
	int border;
	Sprite current_sprite;
	Map *map;

protected:
	void drawContents(QPainter *p);
	void mousePressEvent(QMouseEvent *e);
	void mouseMoveEvent(QMouseEvent *e);
};

#endif // !MAPGRIDFRAME_H
